#ifndef __BRAIN_WINDOW
#define __BRAIN_WINDOW

/* BRAIN GRAPHICAL INTERFACE WINDOW CLASS: */ 
/* This is the main window class, all the other windows inherit from this one	*/ 



class BButton {
public:
	BButton(int x,int y,int dx,int dy,char *text,int id);
	~BButton();

	int m_x;
	int m_y;
	int m_dx;
	int m_dy;
	char *m_text;

	int m_ID;
	bool m_active;
	bool mouse_over;

	void set_active(void) {m_active=true;};
	void set_inactive(void) {m_active=false;};
};


class BWindow {
public:
	BWindow(int x,int y,int dx,int dy,TTF_Font *font);
	virtual ~BWindow();

	virtual bool cycle(int stx,int sty);
	void draw(SDL_Surface *sfc,int x,int y,int dx,int dy);
	void check_mouse(void);
	virtual bool event(SDL_Event *event);

	bool is_dirty();
	void set_dirty();

	void new_window_coordinates(int dx,int dy,int *x,int *y);
	void draw_message(char *message);

protected:
	virtual void contens_size(int *dx,int *dy);
	virtual void draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy);
	virtual bool button_pressed(int ID);

	void local_draw_button(SDL_Surface *sfc,BButton *b,int stx,int sty,bool selected);
	void set_active_button(int ID);
	void set_inactive_button(int ID);

	/* Buffer surface: */ 
	SDL_Surface *buffer_sfc;
	bool dirty;

	/* Coordinates: */ 
	int old_x,old_y;
	int old_dx,old_dy;
	int old_stx,old_sty;
	int old_endx,old_endy;
	int old_vscroller_x,old_vscroller_size,old_vscroller_rsize;
	int old_hscroller_y,old_hscroller_size,old_hscroller_rsize;

	/* Mouse state: */ 
	static int old_mouse_button,old_mouse_x,old_mouse_y;
	static int mouse_button,mouse_x,mouse_y;
	int local_mouse_x,local_mouse_y;

	/* Active window: */ 
	static BWindow *active_window;

	List<BButton> buttons;
	TTF_Font *font;
};

#endif

